package FromDualMySQLaria;

use strict;
use warnings;
use Time::HiRes qw( gettimeofday );

use constant INFO => 1;
use constant WARN => 2;
use constant ERR  => 3;
use constant DBG  => 4;

sub processAriaInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
  'maria_pagecache_buffer_size', 'maria_block_size'
  );

  my @aGlobalStatusToSend = (
  'Maria_pagecache_blocks_not_flushed', 'Maria_pagecache_blocks_unused', 'Maria_pagecache_blocks_used'
, 'Maria_pagecache_reads', 'Maria_pagecache_read_requests', 'Maria_pagecache_writes', 'Maria_pagecache_write_requests'
, 'Maria_transaction_log_syncs'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection(\%$parameter_ref, $dbh);

  # Do some post calculations

  $hGlobalVariables{'maria_pagecache_blocks'} = $hGlobalVariables{'maria_block_size'} == 0 ? 0 : $hGlobalVariables{'maria_pagecache_buffer_size'} / $hGlobalVariables{'maria_block_size'};

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__
