package FromDualMySQLmyisam;

use strict;
use warnings;
use Time::HiRes qw( gettimeofday );

use constant INFO => 1;
use constant WARN => 2;
use constant ERR  => 3;
use constant DBG  => 4;

sub processMyisamInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
    'key_buffer_size', 'key_buffer_blocks'
  );

  my @aGlobalStatusToSend = (
    'Key_blocks_not_flushed', 'Key_blocks_unused'
  , 'Key_blocks_not_flushed', 'Key_blocks_unused', 'Key_blocks_used'
  , 'Key_read_requests', 'Key_reads', 'Key_write_requests', 'Key_writes'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection(\%$parameter_ref, $dbh);

  # Do some post calculations

  $hGlobalVariables{'key_buffer_blocks'} = $hGlobalVariables{'key_cache_block_size'} == 0 ? 0 : $hGlobalVariables{'key_buffer_size'} / $hGlobalVariables{'key_cache_block_size'};

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__