package FromDualMySQLmysql;

use strict;
use warnings;
use Time::HiRes qw( gettimeofday );

use constant INFO => 1;
use constant WARN => 2;
use constant ERR  => 3;
use constant DBG  => 4;

sub processMysqlInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = ('max_connections', 'max_user_connections'
  , 'query_cache_size'
  , 'table_definition_cache', 'table_open_cache', 'table_cache'
  );

  my @aGlobalStatusToSend = ('Aborted_clients', 'Aborted_connects', 'Bytes_received', 'Bytes_sent'
  , 'Com_call_proc'
  , 'Com_delete', 'Com_delete_multi', 'Com_insert', 'Com_insert_select', 'Com_replace', 'Com_replace_select', 'Com_select'
  , 'Com_update', 'Com_update_multi'
  , 'Connections', 'Created_tmp_disk_tables', 'Created_tmp_tables'
  , 'Handler_delete', 'Handler_read_first', 'Handler_read_key', 'Handler_read_next', 'Handler_read_prev'
  , 'Handler_read_rnd', 'Handler_read_rnd_next', 'Handler_update', 'Handler_write'
  , 'Max_used_connections'
  , 'Opened_tables', 'Opened_table_definitions', 'Open_tables', 'Open_table_definitions'
  , 'Qcache_free_blocks', 'Qcache_free_memory', 'Qcache_hits'
  , 'Qcache_inserts', 'Qcache_lowmem_prunes', 'Qcache_not_cached', 'Qcache_queries_in_cache', 'Qcache_total_blocks'
  , 'Queries', 'Questions'
  , 'Select_full_join', 'Select_full_range_join', 'Select_range_check', 'Select_scan', 'Slow_queries'
  , 'Sort_merge_passes', 'Sort_range', 'Sort_rows', 'Sort_scan'
  , 'Table_locks_immediate', 'Table_locks_waited'
  , 'Threads_cached', 'Threads_connected', 'Threads_created', 'Threads_running'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection(\%$parameter_ref, $dbh);

  # Do some post calculations

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__