package FromDualMySQLxtradb;

use strict;
use warnings;
use Time::HiRes qw( gettimeofday );

use constant INFO => 1;
use constant WARN => 2;
use constant ERR  => 3;
use constant DBG  => 4;

sub processXtradbInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
);

  my @aGlobalStatusToSend = (
    'Innodb_buffer_pool_pages_data', 'Innodb_buffer_pool_pages_dirty', 'Innodb_buffer_pool_pages_free'
  , 'Innodb_buffer_pool_pages_misc', 'Innodb_buffer_pool_pages_total'
  , 'Innodb_data_fsyncs', 'Innodb_data_reads', 'Innodb_data_writes'
  , 'Innodb_rows_deleted', 'Innodb_rows_inserted', 'Innodb_rows_read', 'Innodb_rows_updated'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection(\%$parameter_ref, $dbh);

  # Do some post calculations

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__
